const StringReplacePlugin = require("string-replace-webpack-plugin")

exports.modifyWebpackConfig = function({config, stage}, pluginOptions) {

  const apiPrefix = pluginOptions.pathPrefix ? pluginOptions.pathPrefix : /\/lambda/

  switch (stage) {
    case 'develop':

      config.loader('string-replace-loader', {
        test: /\.(js|jsx)$/,
        loader: StringReplacePlugin.replace({
          replacements: [
            {
              pattern: apiPrefix ,
              replacement: function(match, p1, offset, string) {
                return 'http://localhost:9000';
              }
            }
          ]
        })
      })

      config.plugin('string-replace-plugin', StringReplacePlugin)

      break;

    case 'build-javascript':
      config.loader('string-replace-loader', {
        test: /\.(js|jsx)$/,
        loader: StringReplacePlugin.replace({
          replacements: [
            {
              pattern: apiPrefix,
              replacement: function(match, p1, offset, string) {
                return '/.netlify/functions';
              }
            }
          ]
        })
      })

      config.plugin('string-replace-plugin', StringReplacePlugin)
      break;

  }

  return config;
}
